# git ls-remote https://github.com/zerotier/ZeroTierOne.git | grep '1\.1\.6'
%global commit0 4218cd13d5c73b9860568ec651142e16d95559a1

%global _hardened_build 1

Name:           zerotier-one
Version:        1.1.6
Release:        1%{?dist}
Summary:        ZeroTier is a software defined networking layer for Earth

License:        GPLv3+
URL:            https://zerotier.com
Source0:        https://github.com/zerotier/ZeroTierOne/archive/%{commit0}.tar.gz
# by default "strip" is ran on the generated binaries, disable this
Patch0:         %{name}-do-not-strip-binaries.patch
# fix the selftest when controller is enabled
# https://github.com/zerotier/ZeroTierOne/commit/c714e8baa6a634d2a7cc783d8e3ce6ce08a59ddb.patch
Patch1:         %{name}-c714e8baa6a634d2a7cc783d8e3ce6ce08a59ddb.patch

BuildRequires:  miniupnpc-devel >= 2.0
BuildRequires:  json-parser-devel
BuildRequires:  http-parser-devel
BuildRequires:  lz4-devel
BuildRequires:  libnatpmp-devel
BuildRequires:  sqlite-devel
BuildRequires:  rubygem-ronn

%{?systemd_requires}
BuildRequires:  systemd

%description
ZeroTier is a software defined networking layer for Earth.

It can be used for on-premise network virtualization, as a peer to peer VPN 
for mobile teams, for hybrid or multi-data-center cloud deployments, or just 
about anywhere else secure software defined virtual networking is useful.

ZeroTier One is our OS-level client service. It allows Mac, Linux, Windows, 
FreeBSD, and soon other types of clients to join ZeroTier virtual networks 
like conventional VPNs or VLANs. It can run on native systems, VMs, or 
containers (Docker, OpenVZ, etc.).

%prep
%setup -qn ZeroTierOne-%{commit0}
%patch0 -p1
%patch1 -p1

# remove ext dir to make sure we do not use local copies of libs during build
rm -rf ext/

%build
make \
    CXXFLAGS="$RPM_OPT_FLAGS"\
    CFLAGS="$RPM_OPT_FLAGS"\
    LDFLAGS="$RPM_LD_FLAGS"\
    ZT_USE_MINIUPNPC=1\
    ZT_ENABLE_CLUSTER=1\
    ZT_ENABLE_NETWORK_CONTROLLER=1\
    %{?_smp_mflags}\
    one\
    manpages

%install
rm -rf $RPM_BUILD_ROOT
make install DESTDIR=$RPM_BUILD_ROOT

mkdir -p $RPM_BUILD_ROOT%{_unitdir}
cp debian/zerotier-one.service $RPM_BUILD_ROOT%{_unitdir}/%{name}.service

%check 
make \
    CXXFLAGS="$RPM_OPT_FLAGS"\
    CFLAGS="$RPM_OPT_FLAGS"\
    LDFLAGS="$RPM_LD_FLAGS"\
    ZT_USE_MINIUPNPC=1\
    ZT_ENABLE_CLUSTER=1\
    ZT_ENABLE_NETWORK_CONTROLLER=1\
    %{?_smp_mflags}\
    selftest
./zerotier-selftest

%post
%systemd_post zerotier-one.service

%preun
%systemd_preun zerotier-one.service

%postun
%systemd_postun_with_restart zerotier-one.service

%files
%{_sbindir}/*
%{_mandir}/man1/*
%{_mandir}/man8/*
%{_unitdir}/%{name}.service
# compatibility symlinks to binaries
%dir %{_sharedstatedir}/%{name}
%{_sharedstatedir}/%{name}/*

%doc AUTHORS.md README.md
%license LICENSE.GPL-3 COPYING

%changelog
* Mon Jul 04 2016 François Kooman <fkooman@tuxed.net> - 1.1.6-1
- initial package
